ESOLanguageOverrider = {}
ESOLanguageOverrider.AddonName = "ESOLanguageOverrider"

ESOLanguageOverrider.items = {}
ESOLanguageOverrider.pociones = {}
ESOLanguageOverrider.skills = {}

local function itemEquipado(slot)
	return GetItemLink(BAG_WORN, slot)
end

local function obtenerLink(link)
	return link
end

local function obtenerId(id)
	return id
end

local function obtenerSkill(skillType, skillLineIndex, skillIndex)
	return GetSkillAbilityId(skillType, skillLineIndex, skillIndex, true)
end

local nombreOriginal = GetString(SI_TOOLTIP_ITEM_NAME)
ESOLanguageOverrider.entraEnSkill = ZO_Skills_AbilitySlot_OnMouseEnter
ESOLanguageOverrider.saleDeSkill = AbilitySlotOnMouseExitOrg

local function sobreEscribirToolTip(tt, fn, obtenerObjeto)
	local base = tt[fn]
	tt[fn] = function(control, ...)
		local itemLink = obtenerObjeto(...)
		local modificado = false
		
		local formato
		
		if (GetItemLinkItemId(itemLink) ~= nil) then
			local tipoObjeto = GetItemLinkItemType(itemLink)
			if tipoObjeto == ITEMTYPE_POTION then
				local traduccionPocion = ESOLanguageOverrider.pociones[GetItemLinkItemId(itemLink)]
				if traduccionPocion ~= nil then
					local nivel = GetItemLinkRequiredChampionPoints(itemLink)+GetItemLinkRequiredLevel(itemLink)
					local valor = 0
					if nivel > 0 then
						for v in pairs(traduccionPocion) do 
							if nivel < v and (valor == 0 or valor > v) then
								valor = v
							end
						end
						if valor ~= 0 then				
							local item_quality = GetItemLinkQuality(itemLink)
							local item_color = GetString("SI_ITEMQUALITY", item_quality)
							formato = string.format(traduccionPocion[valor])
							SafeAddString(SI_TOOLTIP_ITEM_NAME, formato, 2)
						end 
					else
						formato = string.format(traduccionPocion[0])
						SafeAddString(SI_TOOLTIP_ITEM_NAME, formato, 2)
					end
					modificado = true
				end
			else
				local traduccion = ESOLanguageOverrider.items[GetItemLinkItemId(itemLink)]
				if traduccion ~= nil then
					local item_quality = GetItemLinkQuality(itemLink)
					local item_color = GetString("SI_ITEMQUALITY", item_quality)
					formato = string.format(traduccion)
					SafeAddString(SI_TOOLTIP_ITEM_NAME, formato, 2)
					modificado = true
				end
			end
		end
			
		if modificado then			
			local resultado = base(control, ...)
			SafeAddString(SI_TOOLTIP_ITEM_NAME, nombreOriginal, 2)
			return resultado
		else
			return base(control, ...)
		end
	end
end

local function comparativa(tooltip, tipo, ...)
	if tipo == TOOLTIP_GAME_DATA_EQUIPPED_INFO then
		local itemLink = itemEquipado(...)
		
		if (GetItemLinkItemId(itemLink) ~= nil) then
			if (ESOLanguageOverrider.items[GetItemLinkItemId(itemLink)] ~= nil) then
				local item_quality = GetItemLinkQuality(itemLink)
				local item_color = GetString("SI_ITEMQUALITY", item_quality)
				local formato = string.format(ESOLanguageOverrider.items[GetItemLinkItemId(itemLink)])
				SafeAddString(SI_TOOLTIP_ITEM_NAME, formato, 2)
			else
				SafeAddString(SI_TOOLTIP_ITEM_NAME, nombreOriginal, 2)
			end
		else
			SafeAddString(SI_TOOLTIP_ITEM_NAME, nombreOriginal, 2)
		end
	elseif tipo == TOOLTIP_GAME_DATA_STOLEN then
		SafeAddString(SI_TOOLTIP_ITEM_NAME, nombreOriginal, 2)
	end
end

local function habilidadTooltip(tooltip, tipo, a, b, c, siguiente, ...) 
		local idHabilidad = GetSkillAbilityId(skillType, skillLineIndex, skillIndex, true)
		if (ESOLanguageOverrider.skills[idHabilidad] ~= nil) then
			SafeAddString(SI_ABILITY_TOOLTIP_NAME, ESOLanguageOverrider.skills[idHabilidad] .. "a", 2)
		else
			SafeAddString(SI_ABILITY_TOOLTIP_NAME, siguiente, 2)
			
		end 
		
end

--  function ZO_Tooltip:AddAbilityName(abilityId, hideRank, overrideRank)
--    local abilityName = GetAbilityName(abilityId)


function ESOLanguageOverrider:Init()
	sobreEscribirToolTip(ItemTooltip, "SetAttachedMailItem", GetAttachedItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetBagItem", GetItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetBuybackItem", GetBuybackItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetLootItem", GetLootItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetTradeItem", GetTradeItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetStoreItem", GetStoreItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetTradingHouseListing", GetTradingHouseListingItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetWornItem", itemEquipado)
	sobreEscribirToolTip(ItemTooltip, "SetQuestReward", GetQuestRewardItemLink)
	sobreEscribirToolTip(PopupTooltip, "SetLink", obtenerLink)
	sobreEscribirToolTip(ItemTooltip, "SetTradingHouseItem", GetTradingHouseSearchResultItemLink)
	sobreEscribirToolTip(ItemTooltip, "SetLink", obtenerLink)
	-- sobreEscribirToolTipHabilidad(SkillTooltip, "AddAbilityName", obtenerId)
	
	 

	ZO_PreHookHandler(ComparativeTooltip1, "OnAddGameData", comparativa)
	ZO_PreHookHandler(ComparativeTooltip2, "OnAddGameData", comparativa)
	-- ZO_PreHookHandler(SkillTooltip, "OnAddGameData", habilidadTooltip)

	ESOLanguageOverrider:cargarItems()
	ESOLanguageOverrider:cargarPociones()
	-- ESOLanguageOverrider:cargarSkills()


end

local function OnAddOnLoaded(eventCode, addOnName)
    if(addOnName ~= ESOLanguageOverrider.AddonName) then
	return
    end

	EVENT_MANAGER:UnregisterForEvent(ESOLanguageOverrider.AddonName, EVENT_ADD_ON_LOADED)

	ESOLanguageOverrider:Init()
end

EVENT_MANAGER:RegisterForEvent(ESOLanguageOverrider.AddonName, EVENT_ADD_ON_LOADED, OnAddOnLoaded)